<?php

namespace STM\Competition;

use STM\Team\Team;
use STM\Match\MatchSelection;
use \GetterOfTestingInstances;
use \Exception;
use STM\StmFactory;

/**
 * Test class for Competition.
 * Generated by PHPUnit on 2011-08-27 at 16:38:24.
 * @group competition
 */
class CompetitionTest extends \PHPUnit_Framework_TestCase {

    private $all_competitions;
    private $all_teams;
    private $bad_values;

    protected function setUp() {
        $this->bad_values = array(null, false, array(), new Exception(),);
        $this->all_teams = StmFactory::find()->Team->findAll();
        $this->all_competitions = GetterOfTestingInstances::find_competitions();
    }

    protected function tearDown() {
        
    }

    public function testfindById() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(StmFactory::find()->Competition->findById($value));
        }
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(StmFactory::find()->Competition->findById($competition->getId()) instanceof Competition);
        }
    }

    public function testCreate() {
        foreach ($this->bad_values as $value) {
            CompetitionValidator::init();
            $this->assertFalse(Competition::create($value));
        }
    }

    public function testUpdate() {
        $this->markTestSkipped('test in CompetitionValidator');
    }

    public function testDelete() {
        $this->markTestSkipped('Only database fail.');
    }

    public function testDelete_matches() {
        foreach ($this->all_competitions as $competition) {
            if ($competition->getCountMatches(MatchSelection::ALL_MATCHES) == 0) {
                $this->assertFalse($competition->deleteMatches());
            }
        }
    }

    public function testDelete_team() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->all_teams as $team) {
                if (!$competition->isTeamFromCompetition($team)) {
                    $this->assertFalse($competition->deleteTeam($team));
                }
            }
        }
    }

    public function testDelete_your_team() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->all_teams as $team) {
                if (!$competition->isYourTeam($team->getId())) {
                    $this->assertFalse($competition->deleteYourTeam($team));
                }
            }
        }
    }

    public function testAdd_your_team() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->all_teams as $team) {
                if ($competition->isYourTeam($team->getId())) {
                    $this->assertFalse($competition->addYourTeam($team));
                } else if (!$competition->isTeamFromCompetition($team)) {
                    $this->assertFalse($competition->addYourTeam($team));
                }
            }
        }
    }

    public function testAdd_teams_from_competition() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse($competition->addTeamsFromCompetition($value));
            }
            $this->assertFalse($competition->addTeamsFromCompetition($competition));
        }
    }
    
    public function testAdd_team() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse($competition->addTeam($value));
            }
            foreach ($this->all_teams as $team) {
                if ($competition->isTeamFromCompetition($team)) {
                    $this->assertFalse($competition->addTeam($team));
                }
            }
        }
    }

    public function testIs_your_team() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse($competition->isYourTeam($value));
            }
            if ($competition->getYourTeams()) {
                foreach ($competition->getYourTeams() as $team) {
                    $this->assertTrue($competition->isYourTeam($team->getId()));
                }
            }
        }
    }

    public function testIs_team_from_competition() {
        foreach ($this->all_competitions as $competition) {
            if ($competition->getTeams()) {
                foreach ($competition->getTeams() as $team) {
                    $this->assertTrue($competition->isTeamFromCompetition($team));
                }
            }
        }
    }

    public function testIs_valid_date() {
        foreach ($this->all_competitions as $competition) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse($competition->isValidDate($value));
            }
            $date_start = $competition->getDateStart();
            $date_end = $competition->getEndStart();
            if ($date_start->isValid() && $date_end->isValid()) {
                $this->assertFalse($competition->isValidDate("{$date_start->__toString()} - 10 seconds"));
                $this->assertFalse($competition->isValidDate("{$date_end->__toString()} + 50 seconds"));
            }
        }
    }

    public function testgetTeams() {
        foreach ($this->all_competitions as $competition) {
            if ($competition->getTeams()) {
                foreach ($competition->getTeams() as $team) {
                    $this->assertTrue($team instanceof Team);
                    $this->assertTrue($competition->isTeamFromCompetition($team));
                }
            }
        }
    }

    public function testGet_your_teams() {
        foreach ($this->all_competitions as $competition) {
            if ($competition->getYourTeams()) {
                foreach ($competition->getYourTeams() as $team) {
                    $this->assertTrue($team instanceof Team);
                    $this->assertTrue($competition->isYourTeam($team->getId()));
                }
            }
        }
    }

    public function testGet_count_teams() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_int($competition->getCountTeams()));
        }
    }

    public function testGet_count_matches() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_numeric($competition->getCountMatches()));
            $this->assertTrue(is_numeric($competition->getCountMatches(MatchSelection::ALL_MATCHES)));
            $this->assertTrue(is_numeric($competition->getCountMatches(MatchSelection::PLAYED_MATCHES)));
            $this->assertTrue(is_numeric($competition->getCountMatches(MatchSelection::UPCOMING_MATCHES)));
            foreach ($this->bad_values as $value) {
                $this->assertTrue(is_numeric($competition->getCountMatches($value)));
            }
        }
    }

    public function testGet_id() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_int($competition->getId()));
        }
    }

    public function testGet_score_type() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(in_array($competition->getScoreType(), array('T', 'F')));
        }
    }

    public function testGet_number_of_match_periods() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_int($competition->getNumberOfMatchPeriods()));
        }
    }

    public function testGet_start_date() {
        foreach ($this->all_competitions as $competition) {
            parent::assertInstanceof('\STM\StmDatetime', $competition->getDateStart());
        }
    }

    public function testGet_end_date() {
        foreach ($this->all_competitions as $competition) {
            parent::assertInstanceof('\STM\StmDatetime', $competition->getEndStart());
        }
    }
    
    public function testGet_category_id() {
        foreach ($this->all_competitions as $competition) {
            $id = $competition->getIdCategory();
            $this->assertTrue(is_int($id) || empty($id));
        }
    }
    
    public function testGet_category_name() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_string($competition->getNameCategory()));
        }
    }

    public function testTo_array() {
        foreach ($this->all_competitions as $competition) {
            $array = $competition->toArray();
            $this->assertArrayHasKey('name', $array);
            $this->assertArrayHasKey('match_periods', $array);
            $this->assertArrayHasKey('date_start', $array);
            $this->assertArrayHasKey('date_end', $array);            
            $this->assertArrayHasKey('type', $array);
            $this->assertArrayHasKey('score_type', $array);
            $this->assertArrayHasKey('id_category', $array);
            $this->assertArrayHasKey('category', $array);
        }
    }

    public function test__toString() {
        foreach ($this->all_competitions as $competition) {
            $this->assertTrue(is_string($competition->__toString()));
        }
    }

}

?>
